/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.96 Revision 1.135
1# Copyright 1999-2011 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.96 2011/10/30 14:21:14 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.135 2012/09/06 08:30:00 kensington Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 2|3|4) : ;;
14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 if version_is_at_least 4.8.1; then
40 SRC_URI="http://releases.qt-project.org/qt4/source/${MY_P}.tar.gz"
41 else
42 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
43 fi
44 ;;
45esac
46
47IUSE="aqua debug pch"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && 48[[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE+=" +exceptions"
21 [[ ${CATEGORY}/${PN} != x11-themes/qgtkstyle ]] && 49if version_is_at_least 4.8; then
22 IUSE="+exceptions" 50 [[ ${CATEGORY}/${PN} != x11-libs/qt-webkit ]] && IUSE+=" c++0x"
23else 51 version_is_at_least 4.8.3 || IUSE+=" qpa"
24 MY_P=qt-x11-opensource-src-${MY_PV}
25fi 52fi
26 53
27if version_is_at_least 4.7.99999999; then 54DEPEND="virtual/pkgconfig"
28 IUSE+=" c++0x qpa" 55if [[ ${QT4_BUILD_TYPE} == live ]]; then
56 DEPEND+=" dev-lang/perl"
29fi 57fi
30 58
31HOMEPAGE="http://qt.nokia.com/"
32SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
33
34LICENSE="|| ( LGPL-2.1 GPL-3 )"
35IUSE+=" debug pch aqua"
36
37RDEPEND=" 59RDEPEND="
38 !<x11-libs/qt-assistant-${PV} 60 !<x11-libs/qt-assistant-${PV}:4
39 !>x11-libs/qt-assistant-${PV}-r9999 61 !>x11-libs/qt-assistant-${PV}-r9999:4
62 !<x11-libs/qt-bearer-${PV}:4
63 !>x11-libs/qt-bearer-${PV}-r9999:4
40 !<x11-libs/qt-core-${PV} 64 !<x11-libs/qt-core-${PV}:4
41 !>x11-libs/qt-core-${PV}-r9999 65 !>x11-libs/qt-core-${PV}-r9999:4
42 !<x11-libs/qt-dbus-${PV} 66 !<x11-libs/qt-dbus-${PV}:4
43 !>x11-libs/qt-dbus-${PV}-r9999 67 !>x11-libs/qt-dbus-${PV}-r9999:4
68 !<x11-libs/qt-declarative-${PV}:4
69 !>x11-libs/qt-declarative-${PV}-r9999:4
44 !<x11-libs/qt-demo-${PV} 70 !<x11-libs/qt-demo-${PV}:4
45 !>x11-libs/qt-demo-${PV}-r9999 71 !>x11-libs/qt-demo-${PV}-r9999:4
46 !<x11-libs/qt-gui-${PV} 72 !<x11-libs/qt-gui-${PV}:4
47 !>x11-libs/qt-gui-${PV}-r9999 73 !>x11-libs/qt-gui-${PV}-r9999:4
48 !<x11-libs/qt-multimedia-${PV} 74 !<x11-libs/qt-multimedia-${PV}:4
49 !>x11-libs/qt-multimedia-${PV}-r9999 75 !>x11-libs/qt-multimedia-${PV}-r9999:4
50 !<x11-libs/qt-opengl-${PV} 76 !<x11-libs/qt-opengl-${PV}:4
51 !>x11-libs/qt-opengl-${PV}-r9999 77 !>x11-libs/qt-opengl-${PV}-r9999:4
78 !<x11-libs/qt-openvg-${PV}:4
79 !>x11-libs/qt-openvg-${PV}-r9999:4
52 !<x11-libs/qt-phonon-${PV} 80 !<x11-libs/qt-phonon-${PV}:4
53 !>x11-libs/qt-phonon-${PV}-r9999 81 !>x11-libs/qt-phonon-${PV}-r9999:4
54 !<x11-libs/qt-qt3support-${PV} 82 !<x11-libs/qt-qt3support-${PV}:4
55 !>x11-libs/qt-qt3support-${PV}-r9999 83 !>x11-libs/qt-qt3support-${PV}-r9999:4
56 !<x11-libs/qt-script-${PV} 84 !<x11-libs/qt-script-${PV}:4
57 !>x11-libs/qt-script-${PV}-r9999 85 !>x11-libs/qt-script-${PV}-r9999:4
58 !<x11-libs/qt-sql-${PV} 86 !<x11-libs/qt-sql-${PV}:4
59 !>x11-libs/qt-sql-${PV}-r9999 87 !>x11-libs/qt-sql-${PV}-r9999:4
60 !<x11-libs/qt-svg-${PV} 88 !<x11-libs/qt-svg-${PV}:4
61 !>x11-libs/qt-svg-${PV}-r9999 89 !>x11-libs/qt-svg-${PV}-r9999:4
62 !<x11-libs/qt-test-${PV} 90 !<x11-libs/qt-test-${PV}:4
63 !>x11-libs/qt-test-${PV}-r9999 91 !>x11-libs/qt-test-${PV}-r9999:4
64 !<x11-libs/qt-webkit-${PV} 92 !<x11-libs/qt-webkit-${PV}:4
65 !>x11-libs/qt-webkit-${PV}-r9999 93 !>x11-libs/qt-webkit-${PV}-r9999:4
66 !<x11-libs/qt-xmlpatterns-${PV} 94 !<x11-libs/qt-xmlpatterns-${PV}:4
67 !>x11-libs/qt-xmlpatterns-${PV}-r9999 95 !>x11-libs/qt-xmlpatterns-${PV}-r9999:4
68" 96"
69 97
70S=${WORKDIR}/${MY_P} 98S=${WORKDIR}/${MY_P}
71 99
72# @FUNCTION: qt4-build_pkg_setup 100# @FUNCTION: qt4-build_pkg_setup
73# @DESCRIPTION: 101# @DESCRIPTION:
74# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 102# Sets up PATH and LD_LIBRARY_PATH.
75qt4-build_pkg_setup() { 103qt4-build_pkg_setup() {
76 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX= 104 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
77 105
78 # Protect users by not allowing downgrades between releases 106 # Protect users by not allowing downgrades between releases.
79 # Downgrading revisions within the same release should be allowed 107 # Downgrading revisions within the same release should be allowed.
80 if has_version '>'${CATEGORY}/${P}-r9999 ; then 108 if has_version ">${CATEGORY}/${P}-r9999:4"; then
81 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 109 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
82 eerror "Sanity check to keep you from breaking your system:" 110 eerror " *** Sanity check to keep you from breaking your system ***"
83 eerror " Downgrading Qt is completely unsupported and will break your system!" 111 eerror "Downgrading Qt is completely unsupported and will break your system!"
84 die "aborting to save your system" 112 die "aborting to save your system"
85 else 113 else
86 ewarn "Downgrading Qt is completely unsupported and will break your system!" 114 ewarn "Downgrading Qt is completely unsupported and will break your system!"
87 fi 115 fi
88 fi
89
90 if [[ "${PN}" == "qt-webkit" ]]; then
91 eshopts_push -s extglob
92 if is-flagq '-g?(gdb)?([1-9])'; then
93 echo
94 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
95 ewarn "You may experience really long compilation times and/or increased memory usage."
96 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
97 ewarn "For more info check out bug #307861"
98 echo
99 fi
100 eshopts_pop
101 fi 116 fi
102 117
103 PATH="${S}/bin${PATH:+:}${PATH}" 118 PATH="${S}/bin${PATH:+:}${PATH}"
104 if [[ ${CHOST} != *-darwin* ]]; then 119 if [[ ${CHOST} != *-darwin* ]]; then
105 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 120 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
110 # avoid extract failure. 125 # avoid extract failure.
111 [[ ${CHOST} == *-apple-darwin* ]] && \ 126 [[ ${CHOST} == *-apple-darwin* ]] && \
112 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 127 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
113 ${QT4_EXTRACT_DIRECTORIES}" 128 ${QT4_EXTRACT_DIRECTORIES}"
114 fi 129 fi
115
116 # Make sure ebuilds use the required EAPI
117 if [[ ${EAPI} != [23] ]]; then
118 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
119 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
120 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
121 die "qt4-build eclass requires EAPI=2 or EAPI=3"
122 fi
123
124 if ! version_is_at_least 4.1 $(gcc-version); then
125 ewarn "Using a GCC version lower than 4.1 is not supported!"
126 fi
127} 130}
131
132# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
133# @DEFAULT_UNSET
134# @DESCRIPTION:
135# Space-separated list including the directories that will be extracted from
136# Qt tarball.
128 137
129# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 138# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
139# @DEFAULT_UNSET
130# @DESCRIPTION: 140# @DESCRIPTION:
131# Arguments for build_target_directories. Takes the directories, in which the 141# Arguments for build_target_directories. Takes the directories in which the
132# code should be compiled. This is a space-separated list 142# code should be compiled. This is a space-separated list.
133
134# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
135# @DESCRIPTION:
136# Space separated list including the directories that will be extracted from Qt
137# tarball
138 143
139# @FUNCTION: qt4-build_src_unpack 144# @FUNCTION: qt4-build_src_unpack
140# @DESCRIPTION: 145# @DESCRIPTION:
141# Unpacks the sources 146# Unpacks the sources.
142qt4-build_src_unpack() { 147qt4-build_src_unpack() {
143 setqtenv 148 setqtenv
144 local unpack_p="${MY_P}" 149
145 case "${PV}" in 150 if ! version_is_at_least 4.1 $(gcc-version); then
146 4.8.0_*) 151 ewarn "Using a GCC version lower than 4.1 is not supported."
147 unpack_p="qt-everywhere-opensource-src-${PV/_*}" 152 fi
153
154 if [[ ${PN} == qt-webkit ]]; then
155 eshopts_push -s extglob
156 if is-flagq '-g?(gdb)?([1-9])'; then
157 echo
158 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
159 ewarn "You may experience really long compilation times and/or increased memory usage."
160 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
161 ewarn "For more info check out https://bugs.gentoo.org/307861"
162 echo
163 fi
164 eshopts_pop
165 fi
166
167 case ${QT4_BUILD_TYPE} in
168 live)
169 git-2_src_unpack
148 ;; 170 ;;
171 release)
172 local tarball="${MY_P}.tar.gz" target= targets=
173 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
174 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
175 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
176 do
177 targets+="${MY_P}/${target} "
178 done
179
180 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
181 tar -xzf "${DISTDIR}/${tarball}" ${targets}
182 eend $? || die "failed to unpack"
183 ;;
149 esac 184 esac
150 local target targets=
151 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
152 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \
153 ${QT4_EXTRACT_DIRECTORIES}; do
154 targets+=" ${unpack_p}/${target}"
155 done
156
157 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets}
158 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die
159 case "${PV}" in
160 4.8.0_*)
161 mv ${WORKDIR}/qt-everywhere-opensource-src-${PV/_*} \
162 ${WORKDIR}/qt-everywhere-opensource-src-${MY_PV}
163 ;;
164 esac
165} 185}
166 186
167# @ECLASS-VARIABLE: PATCHES 187# @ECLASS-VARIABLE: PATCHES
188# @DEFAULT_UNSET
168# @DESCRIPTION: 189# @DESCRIPTION:
169# In case you have patches to apply, specify them in PATCHES variable. Make sure 190# PATCHES array variable containing all various patches to be applied.
170# to specify the full path. This variable is necessary for src_prepare phase. 191# This variable is expected to be defined in global scope of ebuild.
171# example: 192# Make sure to specify the full path. This variable is utilised in
172# PATCHES="${FILESDIR}"/mypatch.patch 193# src_unpack/src_prepare phase, based on EAPI.
173# ${FILESDIR}"/mypatch2.patch"
174# 194#
195# @CODE
196# PATCHES=( "${FILESDIR}/mypatch.patch"
197# "${FILESDIR}/patches_folder/" )
198# @CODE
175 199
176# @FUNCTION: qt4-build_src_prepare 200# @FUNCTION: qt4-build_src_prepare
177# @DESCRIPTION: 201# @DESCRIPTION:
178# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 202# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
179# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 203# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
180qt4-build_src_prepare() { 204qt4-build_src_prepare() {
181 setqtenv 205 setqtenv
182 cd "${S}"
183 206
184 # fix qt 4.7 regression that skips -fvisibility=hidden 207 if [[ ${QT4_BUILD_TYPE} == live ]]; then
208 QTDIR="." ./bin/syncqt || die "syncqt failed"
209 fi
210
185 if version_is_at_least "4.7.0_beta1"; then 211 if version_is_at_least 4.7; then
186 sed -e "s/^gcc|g++)/*gcc|*g++)/" \ 212 # avoid X11 dependency in non-gui packages
187 -i config.tests/unix/fvisibility.test ||
188 die "visibility fixing sed failed"
189 fi
190 # fix libx11 dependency on non X packages
191 if version_is_at_least "4.7.0_beta2"; then
192 local NOLIBX11PKG="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns" 213 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
193 has ${PN} ${NOLIBX11PKG} && qt_nolibx11 214 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
194 [[ ${PN} == "qt-assistant" ]] && qt_assistant_cleanup
195 fi 215 fi
196 216
197 if use aqua; then 217 if use aqua; then
198 # provide a proper macx-g++-64 218 # provide a proper macx-g++-64
199 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 219 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
200 220
201 sed -e '/^CONFIG/s:app_bundle::' \ 221 sed -e '/^CONFIG/s:app_bundle::' \
202 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 222 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
203 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 223 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
204 fi 224 fi
205 225
206 if [[ ${PN} != qt-core ]]; then 226 if [[ ${PN} != qt-core ]]; then
207 skip_qmake_build_patch 227 skip_qmake_build
208 skip_project_generation_patch 228 skip_project_generation
209 symlink_binaries_to_buildtree 229 symlink_binaries_to_buildtree
210 fi 230 fi
211 231
212 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 232 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
213 # qmake bus errors with -O2 but -O3 works 233 # qmake bus errors with -O2 or -O3 but -O1 works
234 # Bug 373061
214 replace-flags -O2 -O3 235 replace-flags -O[23] -O1
215 fi 236 fi
216 237
217 # Bug 178652 238 # Bug 178652
218 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 239 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
219 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 240 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
220 append-flags -fno-gcse 241 append-flags -fno-gcse
221 fi 242 fi
222 243
223 if has c++0x ${IUSE//+} && use c++0x; then 244 if use_if_iuse c++0x; then
224 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
225 ewarn "this is an official standard, some of the reverse dependencies"
226 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
227 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
228 ewarn "disabled."
229 append-flags -std=c++0x 245 append-cxxflags -std=c++0x
230 fi 246 fi
247
231 # Unsupported old gcc versions - hardened needs this :( 248 # Unsupported old gcc versions - hardened needs this :(
232 if [[ $(gcc-major-version) -lt 4 ]] ; then 249 if [[ $(gcc-major-version) -lt 4 ]]; then
233 ewarn "Appending -fno-stack-protector to CXXFLAGS" 250 ewarn "Appending -fno-stack-protector to CXXFLAGS"
234 append-cxxflags -fno-stack-protector 251 append-cxxflags -fno-stack-protector
235 # Bug 253127 252 # Bug 253127
236 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 253 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
237 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 254 -i mkspecs/common/g++.conf || die
238 fi 255 fi
239 256
240 # Bug 261632 257 # Bug 261632
241 if use ppc64; then 258 if use ppc64; then
242 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 259 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
243 append-flags -mminimal-toc 260 append-flags -mminimal-toc
244 fi 261 fi
245 262
246 # Bug 282984 && Bug 295530 263 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
247 sed -e "s:\(^SYSTEM_VARIABLES\):CC=\"$(tc-getCC)\"\nCXX=\"$(tc-getCXX)\"\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 264 sed -e "/^SYSTEM_VARIABLES=/i \
248 -i configure || die "sed qmake compilers failed" 265 CC='$(tc-getCC)'\n\
249 # bug 321335 266 CXX='$(tc-getCXX)'\n\
267 CFLAGS='${CFLAGS}'\n\
268 CXXFLAGS='${CXXFLAGS}'\n\
269 LDFLAGS='${LDFLAGS}'\n\
270 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
271 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
272 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
273 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
274 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
275 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
276 -i configure \
277 || die "sed SYSTEM_VARIABLES failed"
278
279 # Respect CC, CXX, LINK and *FLAGS in config.tests
280 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
281 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
282 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
283 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
284 || die "sed config.tests failed"
285
250 if version_is_at_least 4.6; then 286 if ! version_is_at_least 4.8; then
251 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 287 # Strip predefined CFLAGS from mkspecs (bugs 312689 and 352778)
252 xargs -0 \ 288 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
253 sed -e "s:\(\$MAKE\):\1 CC=\"$(tc-getCC)\" CXX=\"$(tc-getCXX)\" LD=\"$(tc-getCXX)\" LINK=\"$(tc-getCXX)\":g" \
254 -i || die "sed test compilers failed"
255 fi 289 fi
256 290
257 # Bug 172219 291 # Bug 172219
258 sed -e "s:X11R6/::" \ 292 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
259 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
260 293
261 if [[ ${CHOST} == *-darwin* ]]; then 294 if [[ ${CHOST} == *-darwin* ]]; then
262 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 295 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
263 # crippled (by design) :/ 296 # crippled (by design) :/
297 local mac_gpp_conf=
298 if [[ -f mkspecs/common/mac-g++.conf ]]; then
299 # qt < 4.8 has mac-g++.conf
300 mac_gpp_conf="mkspecs/common/mac-g++.conf"
301 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
302 # qt >= 4.8 has g++-macx.conf
303 mac_gpp_conf="mkspecs/common/g++-macx.conf"
304 else
305 die "no known conf file for mac found"
306 fi
307 sed \
264 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 308 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
265 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 309 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
266 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 310 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
267 -e "s:-arch\s\w*::g" \ 311 -e "s:-arch\s\w*::g" \
268 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 312 -i ${mac_gpp_conf} \
313 || die "sed ${mac_gpp_conf} failed"
269 314
270 # Fix configure's -arch settings that appear in qmake/Makefile and also 315 # Fix configure's -arch settings that appear in qmake/Makefile and also
271 # fix arch handling (automagically duplicates our -arch arg and breaks 316 # fix arch handling (automagically duplicates our -arch arg and breaks
272 # pch). Additionally disable Xarch support. 317 # pch). Additionally disable Xarch support.
318 local mac_gcc_confs="${mac_gpp_conf}"
319 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
320 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
321 fi
273 sed \ 322 sed \
274 -e "s:-arch i386::" \ 323 -e "s:-arch i386::" \
275 -e "s:-arch ppc::" \ 324 -e "s:-arch ppc::" \
276 -e "s:-arch x86_64::" \ 325 -e "s:-arch x86_64::" \
277 -e "s:-arch ppc64::" \ 326 -e "s:-arch ppc64::" \
278 -e "s:-arch \$i::" \ 327 -e "s:-arch \$i::" \
279 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 328 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
280 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 329 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
281 -e "s:-Xarch_x86_64::g" \ 330 -e "s:-Xarch_x86_64::g" \
282 -e "s:-Xarch_ppc64::g" \ 331 -e "s:-Xarch_ppc64::g" \
283 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 332 -i configure ${mac_gcc_confs} \
333 || die "sed -arch/-Xarch failed"
284 334
285 # On Snow Leopard don't fall back to 10.5 deployment target. 335 # On Snow Leopard don't fall back to 10.5 deployment target.
286 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 336 if [[ ${CHOST} == *-apple-darwin10 ]]; then
287 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 337 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
288 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 338 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
289 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 339 -i configure ${mac_gpp_conf} \
340 || die "sed deployment target failed"
290 fi 341 fi
291 fi 342 fi
292 343
293 # this one is needed for all systems with a separate -liconv, apart from 344 # this one is needed for all systems with a separate -liconv, apart from
294 # Darwin, for which the sources already cater for -liconv 345 # Darwin, for which the sources already cater for -liconv
295 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 346 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
296 sed \ 347 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
297 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
298 -i config.tests/unix/iconv/iconv.pro \ 348 -i config.tests/unix/iconv/iconv.pro \
299 || die "sed on iconv.pro failed" 349 || die "sed iconv.pro failed"
300 fi 350 fi
301 351
302 # we need some patches for Solaris 352 # we need some patches for Solaris
303 sed -i \
304 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 353 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
305 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 354 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
306 # use GCC over SunStudio 355 # use GCC over SunStudio
307 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 356 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
308 # don't flirt with non-Prefix stuff, we're quite possessive 357 # do not flirt with non-Prefix stuff, we're quite possessive
309 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 358 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
310 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 359 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
311 # strip predefined CFLAGS from qmake ( bug #312689 )
312 sed -i '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf
313 360
314 base_src_prepare 361 # apply patches
362 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
363 epatch_user
315} 364}
316 365
317# @FUNCTION: qt4-build_src_configure 366# @FUNCTION: qt4-build_src_configure
318# @DESCRIPTION: 367# @DESCRIPTION:
319# Default configure phase 368# Default configure phase
320qt4-build_src_configure() { 369qt4-build_src_configure() {
321 setqtenv 370 setqtenv
322 myconf="$(standard_configure_options) ${myconf}" 371
372 local conf="
373 -prefix ${QTPREFIXDIR}
374 -bindir ${QTBINDIR}
375 -libdir ${QTLIBDIR}
376 -docdir ${QTDOCDIR}
377 -headerdir ${QTHEADERDIR}
378 -plugindir ${QTPLUGINDIR}
379 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
380 -datadir ${QTDATADIR}
381 -translationdir ${QTTRANSDIR}
382 -sysconfdir ${QTSYSCONFDIR}
383 -examplesdir ${QTEXAMPLESDIR}
384 -demosdir ${QTDEMOSDIR}
385 -opensource -confirm-license
386 -shared -fast -largefile -stl -verbose
387 -nomake examples -nomake demos"
388
389 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
390 # $(tc-arch). Therefore we convert it to supported values.
391 case "$(tc-arch)" in
392 amd64|x64-*) conf+=" -arch x86_64" ;;
393 ppc-macos) conf+=" -arch ppc" ;;
394 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
395 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
396 x86-macos) conf+=" -arch x86" ;;
397 x86|x86-*) conf+=" -arch i386" ;;
398 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
399 hppa|sh) conf+=" -arch generic" ;;
400 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
401 esac
402
403 conf+=" -platform $(qt_mkspecs_dir)"
404
405 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
406
407 # debug/release
408 if use debug; then
409 conf+=" -debug"
410 else
411 conf+=" -release"
412 fi
413 conf+=" -no-separate-debug-info"
414
415 # exceptions USE flag
416 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
417
418 # disable rpath on Qt >= 4.8 (bug 380415)
419 # but leave it enabled on prefix (bug 417169)
420 version_is_at_least 4.8 && use !prefix && conf+=" -no-rpath"
421
422 # precompiled headers don't work on hardened, where the flag is masked
423 conf+=" $(qt_use pch)"
424
425 # -reduce-relocations
426 # This flag seems to introduce major breakage to applications,
427 # mostly to be seen as a core dump with the message "QPixmap: Must
428 # construct a QApplication before a QPaintDevice" on Solaris.
429 # -- Daniel Vergien
430 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
323 431
324 # this one is needed for all systems with a separate -liconv, apart from 432 # this one is needed for all systems with a separate -liconv, apart from
325 # Darwin, for which the sources already cater for -liconv 433 # Darwin, for which the sources already cater for -liconv
326 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 434 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
327 myconf+=" -liconv" 435 conf+=" -liconv"
436 fi
328 437
329 if has glib ${IUSE//+} && use glib; then 438 if use_if_iuse glib; then
330 # use -I, -L and -l from configure
331 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 439 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
332 # avoid the -pthread argument 440 # avoid the -pthread argument
333 myconf+=" ${glibflags//-pthread}" 441 conf+=" ${glibflags//-pthread}"
334 unset glibflags 442 unset glibflags
335 fi 443 fi
336 444
337 if has qpa ${IUSE//+} && use qpa; then 445 if use_if_iuse qpa; then
338 ewarn 446 echo
339 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely" 447 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
340 ewarn "known as Qt Lighthouse. If you are not sure what that is, then" 448 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
341 ewarn "disable it before reporting any bugs related to this useflag." 449 ewarn "disable it before reporting any bugs related to this useflag."
342 ewarn 450 echo
343 myconf+=" -qpa" 451 conf+=" -qpa"
344 fi 452 fi
345 453
346 if use aqua ; then 454 if use aqua; then
347 # On (snow) leopard use the new (frameworked) cocoa code. 455 # On (snow) leopard use the new (frameworked) cocoa code.
348 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 456 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
349 myconf+=" -cocoa -framework" 457 conf+=" -cocoa -framework"
458 # We need the source's headers, not the installed ones.
459 conf+=" -I${S}/include"
460 # Add hint for the framework location.
461 conf+=" -F${QTLIBDIR}"
350 462
351 # We are crazy and build cocoa + qt3support :-) 463 # We are crazy and build cocoa + qt3support :-)
352 if use qt3support; then 464 if use qt3support; then
353 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 465 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
354 -i configure 466 -i configure || die
355 fi 467 fi
356 468 else
357 # We need the source's headers, not the installed ones. 469 conf+=" -no-framework"
358 myconf+=" -I${S}/include"
359
360 # Add hint for the framework location.
361 myconf+=" -F${QTLIBDIR}"
362 fi 470 fi
363 else 471 else
364 # freetype2 include dir is non-standard, thus include it on configure 472 # freetype2 include dir is non-standard, thus pass it to configure
365 # use -I from configure
366 myconf+=" $(pkg-config --cflags freetype2)" 473 conf+=" $(pkg-config --cflags-only-I freetype2)"
367 fi 474 fi
368 475
369 # Disable SSE4.x, since auto-detection is currently broken 476 conf+=" ${myconf}"
370 # Upstream bug http://bugreports.qt.nokia.com/browse/QTBUG-13623 477 myconf=
371 [[ ${PV} == "4.7.1" ]] && myconf+=" -no-sse4.1 -no-sse4.2"
372 478
373 echo ./configure ${myconf} 479 echo ./configure ${conf}
374 ./configure ${myconf} || die "./configure failed" 480 ./configure ${conf} || die "./configure failed"
375 myconf=""
376 481
377 prepare_directories ${QT4_TARGET_DIRECTORIES} 482 prepare_directories ${QT4_TARGET_DIRECTORIES}
378} 483}
379 484
380# @FUNCTION: qt4-build_src_compile 485# @FUNCTION: qt4-build_src_compile
388 493
389# @FUNCTION: qt4-build_src_test 494# @FUNCTION: qt4-build_src_test
390# @DESCRIPTION: 495# @DESCRIPTION:
391# Runs tests only in target directories. 496# Runs tests only in target directories.
392qt4-build_src_test() { 497qt4-build_src_test() {
498 # QtMultimedia does not have any test suite (bug #332299)
499 [[ ${PN} == qt-multimedia ]] && return
500
393 for dir in ${QT4_TARGET_DIRECTORIES}; do 501 for dir in ${QT4_TARGET_DIRECTORIES}; do
394 emake -j1 check -C ${dir} 502 emake -j1 check -C ${dir}
395 done 503 done
396} 504}
397 505
398# @FUNCTION: fix_includes 506# @FUNCTION: fix_includes
399# @DESCRIPTION: 507# @DESCRIPTION:
400# For MacOSX we need to add some symlinks when frameworks are 508# For MacOS X we need to add some symlinks when frameworks are
401# being used, to avoid complications with some more or less stupid packages. 509# being used, to avoid complications with some more or less stupid packages.
402fix_includes() { 510fix_includes() {
403 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 511 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
512 local frw dest f h rdir
404 # Some packages tend to include <Qt/...> 513 # Some packages tend to include <Qt/...>
405 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 514 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
406 515
407 # Fake normal headers when frameworks are installed... eases life later on 516 # Fake normal headers when frameworks are installed... eases life later
408 local dest f 517 # on, make sure we use relative links though, as some ebuilds assume
518 # these dirs exist in src_install to add additional files
519 f=${QTHEADERDIR}
520 h=${QTLIBDIR}
521 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
522 f=${f#*/}
523 h=${h#*/}
524 done
525 rdir=${h}
526 f="../"
527 while [[ ${h} == */* ]] ; do
528 f="${f}../"
529 h=${h#*/}
530 done
531 rdir="${f}${rdir}"
532
409 for frw in "${D}${QTLIBDIR}"/*.framework; do 533 for frw in "${D}${QTLIBDIR}"/*.framework; do
410 [[ -e "${frw}"/Headers ]] || continue 534 [[ -e "${frw}"/Headers ]] || continue
411 f=$(basename ${frw}) 535 f=$(basename ${frw})
412 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 536 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
413 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 537 dosym "${rdir}"/${f}/Headers "${dest}"
414 538
415 # Link normal headers as well. 539 # Link normal headers as well.
416 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 540 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
417 h=$(basename ${hdr}) 541 h=$(basename ${hdr})
418 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 542 dosym "../${rdir}"/${f}/Headers/${h} \
543 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
419 done 544 done
420 done 545 done
421 fi 546 fi
422} 547}
423 548
425# @DESCRIPTION: 550# @DESCRIPTION:
426# Perform the actual installation including some library fixes. 551# Perform the actual installation including some library fixes.
427qt4-build_src_install() { 552qt4-build_src_install() {
428 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D} 553 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
429 setqtenv 554 setqtenv
555
430 install_directories ${QT4_TARGET_DIRECTORIES} 556 install_directories ${QT4_TARGET_DIRECTORIES}
431 install_qconfigs 557 install_qconfigs
432 fix_library_files 558 fix_library_files
433 fix_includes 559 fix_includes
560
434 # remove .la files since we are building only shared Qt libraries 561 # remove .la files since we are building only shared Qt libraries
435 find "${D}"${QTLIBDIR} -name "*.la" -print0 | xargs -0 rm 562 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
436} 563}
437 564
438# @FUNCTION: setqtenv 565# @FUNCTION: setqtenv
566# @INTERNAL
439setqtenv() { 567setqtenv() {
440 # Set up installation directories 568 # Set up installation directories
441 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
442 QTPREFIXDIR=${EPREFIX}/usr 569 QTPREFIXDIR=${EPREFIX}/usr
443 QTBINDIR=${EPREFIX}/usr/bin 570 QTBINDIR=${EPREFIX}/usr/bin
444 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 571 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
445 QMAKE_LIBDIR_QT=${QTLIBDIR}
446 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 572 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
447 QTDATADIR=${EPREFIX}/usr/share/qt4
448 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 573 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
449 QTHEADERDIR=${EPREFIX}/usr/include/qt4 574 QTHEADERDIR=${EPREFIX}/usr/include/qt4
450 QTPLUGINDIR=${QTLIBDIR}/plugins 575 QTPLUGINDIR=${QTLIBDIR}/plugins
576 QTIMPORTDIR=${QTLIBDIR}/imports
577 QTDATADIR=${EPREFIX}/usr/share/qt4
578 QTTRANSDIR=${QTDATADIR}/translations
451 QTSYSCONFDIR=${EPREFIX}/etc/qt4 579 QTSYSCONFDIR=${EPREFIX}/etc/qt4
452 QTTRANSDIR=${QTDATADIR}/translations
453 QTEXAMPLESDIR=${QTDATADIR}/examples 580 QTEXAMPLESDIR=${QTDATADIR}/examples
454 QTDEMOSDIR=${QTDATADIR}/demos 581 QTDEMOSDIR=${QTDATADIR}/demos
582 QMAKE_LIBDIR_QT=${QTLIBDIR}
455 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 583 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
584
456 PLATFORM=$(qt_mkspecs_dir) 585 PLATFORM=$(qt_mkspecs_dir)
457
458 unset QMAKESPEC 586 unset QMAKESPEC
459}
460 587
461# @FUNCTION: standard_configure_options 588 export XDG_CONFIG_HOME="${T}"
462# @DESCRIPTION:
463# Sets up some standard configure options, like libdir (if necessary), whether
464# debug info is wanted or not.
465standard_configure_options() {
466 local myconf=
467
468 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)"
469
470 # Disable visibility explicitly if gcc version isn't 4
471 if [[ $(gcc-major-version) -lt 4 ]]; then
472 myconf+=" -no-reduce-exports"
473 fi
474
475 # precompiled headers doesn't work on hardened, where the flag is masked.
476 myconf+=" $(qt_use pch)"
477
478 if use debug; then
479 myconf+=" -debug"
480 else
481 myconf+=" -release"
482 fi
483 myconf+=" -no-separate-debug-info"
484
485 use aqua && myconf+=" -no-framework"
486
487 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
488 # $(tc-arch). Therefore we convert it to supported values.
489 case "$(tc-arch)" in
490 amd64|x64-*) myconf+=" -arch x86_64" ;;
491 ppc-macos) myconf+=" -arch ppc" ;;
492 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
493 sparc|sparc-*) myconf+=" -arch sparc" ;;
494 x86-macos) myconf+=" -arch x86" ;;
495 x86|x86-*) myconf+=" -arch i386" ;;
496 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
497 hppa|sh) myconf+=" -arch generic" ;;
498 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
499 esac
500
501 # 4.5: build everything but qt-xmlpatterns w/o exceptions
502 # 4.6: exceptions USE flag
503 local exceptions="-exceptions"
504 case "${PV}" in
505 4.5.*)
506 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
507 ;;
508 *)
509 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
510 ;;
511 esac
512
513 # note about -reduce-relocations:
514 # That flag seems to introduce major breakage to applications,
515 # mostly to be seen as a core dump with the message "QPixmap: Must
516 # construct a QApplication before a QPaintDevice" on Solaris
517 # -- Daniel Vergien
518 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
519
520 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
521 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
522 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
523 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
524 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
525 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
526 ${exceptions}
527 -nomake examples -nomake demos"
528
529 echo "${myconf}"
530} 589}
531 590
532# @FUNCTION: prepare_directories 591# @FUNCTION: prepare_directories
533# @USAGE: < directories > 592# @USAGE: < directories >
593# @INTERNAL
534# @DESCRIPTION: 594# @DESCRIPTION:
535# Generates makefiles for the directories set in $QT4_TARGET_DIRECTORIES 595# Generates Makefiles for the given list of directories.
536prepare_directories() { 596prepare_directories() {
537 for x in "$@"; do 597 for x in "$@"; do
538 pushd "${S}"/${x} >/dev/null 598 pushd "${S}"/${x} >/dev/null || die
539 einfo "running qmake in: $x" 599 einfo "Running qmake in: ${x}"
540 # avoid running over the maximum argument number, bug #299810 600 # avoid running over the maximum argument number, bug #299810
541 { 601 {
542 echo "${S}"/mkspecs/common/*.conf 602 echo "${S}"/mkspecs/common/*.conf
543 find "${S}" -name '*.pr[io]' 603 find "${S}" -name '*.pr[io]'
544 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die 604 } | xargs sed -i \
605 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
606 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
607 || die
545 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 608 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
546 popd >/dev/null 609 popd >/dev/null || die
547 done 610 done
548} 611}
549 612
550 613
551# @FUNCTION: build_directories 614# @FUNCTION: build_directories
552# @USAGE: < directories > 615# @USAGE: < directories >
616# @INTERNAL
553# @DESCRIPTION: 617# @DESCRIPTION:
554# Compiles the code in $QT4_TARGET_DIRECTORIES 618# Compiles the code in the given list of directories.
555build_directories() { 619build_directories() {
556 for x in "$@"; do 620 for x in "$@"; do
557 pushd "${S}"/${x} >/dev/null 621 pushd "${S}"/${x} >/dev/null || die
558 emake CC="$(tc-getCC)" \ 622 emake CC="$(tc-getCC)" \
559 CXX="$(tc-getCXX)" \ 623 CXX="$(tc-getCXX)" \
560 LINK="$(tc-getCXX)" || die "emake failed" 624 LINK="$(tc-getCXX)" || die "emake failed"
561 popd >/dev/null 625 popd >/dev/null || die
562 done 626 done
563} 627}
564 628
565# @FUNCTION: install_directories 629# @FUNCTION: install_directories
566# @USAGE: < directories > 630# @USAGE: < directories >
631# @INTERNAL
567# @DESCRIPTION: 632# @DESCRIPTION:
568# run emake install in the given directories, which are separated by spaces 633# Runs emake install in the given directories, which are separated by spaces.
569install_directories() { 634install_directories() {
570 for x in "$@"; do 635 for x in "$@"; do
571 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 636 pushd "${S}"/${x} >/dev/null || die
572 emake INSTALL_ROOT="${D}" install || die "emake install failed" 637 emake INSTALL_ROOT="${D}" install || die "emake install failed"
573 popd >/dev/null || die "Can't popd from ${S}/${x}" 638 popd >/dev/null || die
574 done 639 done
575} 640}
576 641
577# @ECLASS-VARIABLE: QCONFIG_ADD 642# @ECLASS-VARIABLE: QCONFIG_ADD
578# @DESCRIPTION: 643# @DESCRIPTION:
588# @DESCRIPTION: 653# @DESCRIPTION:
589# List variables that should be defined at the top of QtCore/qconfig.h 654# List variables that should be defined at the top of QtCore/qconfig.h
590: ${QCONFIG_DEFINE:=} 655: ${QCONFIG_DEFINE:=}
591 656
592# @FUNCTION: install_qconfigs 657# @FUNCTION: install_qconfigs
658# @INTERNAL
593# @DESCRIPTION: 659# @DESCRIPTION:
594# Install gentoo-specific mkspecs configurations 660# Install gentoo-specific mkspecs configurations.
595install_qconfigs() { 661install_qconfigs() {
596 local x 662 local x
597 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 663 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
598 for x in QCONFIG_ADD QCONFIG_REMOVE; do 664 for x in QCONFIG_ADD QCONFIG_REMOVE; do
599 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 665 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
610 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 676 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
611 fi 677 fi
612} 678}
613 679
614# @FUNCTION: generate_qconfigs 680# @FUNCTION: generate_qconfigs
681# @INTERNAL
615# @DESCRIPTION: 682# @DESCRIPTION:
616# Generates gentoo-specific configurations 683# Generates gentoo-specific qconfig.{h,pri}.
617generate_qconfigs() { 684generate_qconfigs() {
618 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 685 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
619 local x qconfig_add qconfig_remove qconfig_new 686 local x qconfig_add qconfig_remove qconfig_new
620 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 687 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
621 [[ -f ${x} ]] || continue 688 [[ -f ${x} ]] || continue
622 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 689 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
623 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 690 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
670 fi 737 fi
671} 738}
672 739
673# @FUNCTION: qt4-build_pkg_postrm 740# @FUNCTION: qt4-build_pkg_postrm
674# @DESCRIPTION: 741# @DESCRIPTION:
675# Generate configurations when the package is completely removed 742# Regenerate configuration when the package is completely removed.
676qt4-build_pkg_postrm() { 743qt4-build_pkg_postrm() {
677 generate_qconfigs 744 generate_qconfigs
678} 745}
679 746
680# @FUNCTION: qt4-build_pkg_postinst 747# @FUNCTION: qt4-build_pkg_postinst
681# @DESCRIPTION: 748# @DESCRIPTION:
682# Generate configuration, plus throws a message about possible 749# Regenerate configuration, plus throw a message about possible
683# breakages and proposed solutions. 750# breakages and proposed solutions.
684qt4-build_pkg_postinst() { 751qt4-build_pkg_postinst() {
685 generate_qconfigs 752 generate_qconfigs
686} 753}
687 754
688# @FUNCTION: skip_qmake_build_patch 755# @FUNCTION: skip_qmake_build
756# @INTERNAL
689# @DESCRIPTION: 757# @DESCRIPTION:
690# Don't need to build qmake, as it's already installed from qt-core 758# Patches configure to skip qmake compilation, as it's already installed by qt-core.
691skip_qmake_build_patch() { 759skip_qmake_build() {
692 # Don't need to build qmake, as it's already installed from qt-core
693 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 760 sed -i -e "s:if true:if false:g" "${S}"/configure || die
694} 761}
695 762
696# @FUNCTION: skip_project_generation_patch 763# @FUNCTION: skip_project_generation
764# @INTERNAL
697# @DESCRIPTION: 765# @DESCRIPTION:
698# Exit the script early by throwing in an exit before all of the .pro files are scanned 766# Exit the script early by throwing in an exit before all of the .pro files are scanned.
699skip_project_generation_patch() { 767skip_project_generation() {
700 # Exit the script early by throwing in an exit before all of the .pro files are scanned
701 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 768 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
702 -i "${S}"/configure || die "Sed failed"
703} 769}
704 770
705# @FUNCTION: symlink_binaries_to_buildtree 771# @FUNCTION: symlink_binaries_to_buildtree
772# @INTERNAL
706# @DESCRIPTION: 773# @DESCRIPTION:
707# Symlink generated binaries to buildtree so they can be used during compilation 774# Symlinks generated binaries to buildtree, so they can be used during compilation time.
708# time
709symlink_binaries_to_buildtree() { 775symlink_binaries_to_buildtree() {
710 for bin in qmake moc uic rcc; do 776 for bin in qmake moc uic rcc; do
711 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 777 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
712 done 778 done
713} 779}
714 780
715# @FUNCTION: fix_library_files 781# @FUNCTION: fix_library_files
782# @INTERNAL
716# @DESCRIPTION: 783# @DESCRIPTION:
717# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 784# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
718# moves the *.pc-files into the pkgconfig directory 785# moves the *.pc files into the pkgconfig directory.
719fix_library_files() { 786fix_library_files() {
787 local libfile
720 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 788 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
721 if [[ -e ${libfile} ]]; then 789 if [[ -e ${libfile} ]]; then
722 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 790 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
723 fi 791 fi
724 done 792 done
725 793
726 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 794 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
727 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 795 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
728 if [[ -e ${libfile} ]]; then 796 if [[ -e ${libfile} ]]; then
729 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 797 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
730 798
731 # Move .pc files into the pkgconfig directory 799 # Move .pc files into the pkgconfig directory
732 dodir ${QTPCDIR#${EPREFIX}} 800 dodir ${QTPCDIR#${EPREFIX}}
733 mv ${libfile} "${D}"/${QTPCDIR}/ \ 801 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
734 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
735 fi 802 fi
736 done 803 done
737 804
738 # Don't install an empty directory 805 # Don't install an empty directory
739 rmdir "${D}"/${QTLIBDIR}/pkgconfig 806 rmdir "${D}"/${QTLIBDIR}/pkgconfig
740} 807}
741 808
742# @FUNCTION: qt_use 809# @FUNCTION: qt_use
743# @USAGE: < flag > [ feature ] [ enableval ] 810# @USAGE: < flag > [ feature ] [ enableval ]
744# @DESCRIPTION: 811# @DESCRIPTION:
745# This will echo "${enableval}-${feature}" if <flag> is enabled, or 812# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
746# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 813# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
747# will be used for that. If [enableval] is not specified, it omits the 814# will be used for that. If [enableval] is not specified, it omits the
748# assignment-part 815# "-${enableval}" part.
749qt_use() { 816qt_use() {
750 local flag=$1 817 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
751 local feature=$1
752 local enableval=
753
754 [[ -n $2 ]] && feature=$2
755 [[ -n $3 ]] && enableval=-$3
756
757 if use ${flag}; then
758 echo "${enableval}-${feature}"
759 else
760 echo "-no-${feature}"
761 fi
762} 818}
763 819
764# @FUNCTION: qt_mkspecs_dir 820# @FUNCTION: qt_mkspecs_dir
765# @RETURN: the specs-directory w/o path 821# @RETURN: the specs-directory w/o path
766# @DESCRIPTION: 822# @DESCRIPTION:
767# Allows us to define which mkspecs dir we want to use. 823# Allows us to define which mkspecs dir we want to use.
768qt_mkspecs_dir() { 824qt_mkspecs_dir() {
769 # Allows us to define which mkspecs dir we want to use.
770 local spec 825 local spec=
771 826
772 case ${CHOST} in 827 case "${CHOST}" in
773 *-freebsd*|*-dragonfly*) 828 *-freebsd*|*-dragonfly*)
774 spec=freebsd ;; 829 spec=freebsd ;;
775 *-openbsd*) 830 *-openbsd*)
776 spec=openbsd ;; 831 spec=openbsd ;;
777 *-netbsd*) 832 *-netbsd*)
788 *-solaris*) 843 *-solaris*)
789 spec=solaris ;; 844 spec=solaris ;;
790 *-linux-*|*-linux) 845 *-linux-*|*-linux)
791 spec=linux ;; 846 spec=linux ;;
792 *) 847 *)
793 die "Unknown CHOST, no platform choosen." 848 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
794 esac 849 esac
795 850
796 CXX=$(tc-getCXX) 851 case "$(tc-getCXX)" in
797 if [[ ${CXX} == *g++* ]]; then 852 *g++*)
798 spec+=-g++ 853 spec+=-g++ ;;
799 elif [[ ${CXX} == *icpc* ]]; then 854 *icpc*)
800 spec+=-icc 855 spec+=-icc ;;
801 else 856 *)
802 die "Unknown compiler ${CXX}." 857 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
803 fi 858 esac
804 if [[ -n ${LIBDIR/lib} ]]; then
805 spec+=-${LIBDIR/lib}
806 fi
807 859
808 # Add -64 for 64bit profiles 860 # Add -64 for 64bit profiles
809 if use x64-freebsd || 861 if use x64-freebsd ||
810 use amd64-linux || 862 use amd64-linux ||
811 use x64-macos || 863 use x64-macos ||
816 fi 868 fi
817 869
818 echo "${spec}" 870 echo "${spec}"
819} 871}
820 872
821# @FUNCTION: qt_assistant_cleanup
822# @RETURN: nothing
823# @DESCRIPTION:
824# Tries to clean up tools.pro for qt-assistant ebuilds
825# Meant to be called in src_prepare
826qt_assistant_cleanup() {
827 # different versions (and branches...) may need different handling,
828 # add a case if you need special handling
829 case "${MY_PV_EXTRA}" in
830 *kde-qt*)
831 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
832 -e "/mac/,/^embedded.*makeqpf$/d" \
833 -i tools/tools.pro || die "patching tools.pro failed"
834 ;;
835 *)
836 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
837 -e "/mac/,/^embedded.*makeqpf$/d" \
838 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
839 -i tools/tools.pro || die "patching tools.pro failed"
840 ;;
841 esac
842}
843
844# @FUNCTION: qt_nolibx11 873# @FUNCTION: qt_nolibx11
845# @RETURN: nothing 874# @INTERNAL
846# @DESCRIPTION: 875# @DESCRIPTION:
847# Ignore X11 tests for packages that don't need X libraries installed 876# Ignore X11 tests for packages that don't need X libraries installed.
848qt_nolibx11() { 877qt_nolibx11() {
849 einfo "removing X11 check to allow X-less compilation"
850 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure || 878 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
851 die "x11 check sed failed" 879 die "x11 check sed failed"
852} 880}
853 881
854EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 882EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.96  
changed lines
  Added in v.1.135

  ViewVC Help
Powered by ViewVC 1.1.20